# coding: utf-8

"""
    Open Agent API

    An API for creating and interacting with AI agents, including chat completions, autonomous agents with tool usage, multi-agent teams, knowledge base search, and optional billing integration. Clients can authenticate via magic link or OAuth2 to obtain a token, or use API keys. 

    The version of the OpenAPI document: 0.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from open_agent_api.models.run_completed_event import RunCompletedEvent
from open_agent_api.models.run_response_event import RunResponseEvent
from open_agent_api.models.run_started_event import RunStartedEvent
from open_agent_api.models.tool_call_completed_event import ToolCallCompletedEvent
from open_agent_api.models.tool_call_started_event import ToolCallStartedEvent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SSEENDPOINTMCPSSEGET200RESPONSEDATA_ONE_OF_SCHEMAS = ["RunCompletedEvent", "RunResponseEvent", "RunStartedEvent", "ToolCallCompletedEvent", "ToolCallStartedEvent"]

class SseEndpointMcpSseGet200ResponseData(BaseModel):
    """
    SseEndpointMcpSseGet200ResponseData
    """
    # data type: RunResponseEvent
    oneof_schema_1_validator: Optional[RunResponseEvent] = None
    # data type: RunStartedEvent
    oneof_schema_2_validator: Optional[RunStartedEvent] = None
    # data type: RunCompletedEvent
    oneof_schema_3_validator: Optional[RunCompletedEvent] = None
    # data type: ToolCallStartedEvent
    oneof_schema_4_validator: Optional[ToolCallStartedEvent] = None
    # data type: ToolCallCompletedEvent
    oneof_schema_5_validator: Optional[ToolCallCompletedEvent] = None
    actual_instance: Optional[Union[RunCompletedEvent, RunResponseEvent, RunStartedEvent, ToolCallCompletedEvent, ToolCallStartedEvent]] = None
    one_of_schemas: Set[str] = { "RunCompletedEvent", "RunResponseEvent", "RunStartedEvent", "ToolCallCompletedEvent", "ToolCallStartedEvent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SseEndpointMcpSseGet200ResponseData.model_construct()
        error_messages = []
        match = 0
        # validate data type: RunResponseEvent
        if not isinstance(v, RunResponseEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RunResponseEvent`")
        else:
            match += 1
        # validate data type: RunStartedEvent
        if not isinstance(v, RunStartedEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RunStartedEvent`")
        else:
            match += 1
        # validate data type: RunCompletedEvent
        if not isinstance(v, RunCompletedEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RunCompletedEvent`")
        else:
            match += 1
        # validate data type: ToolCallStartedEvent
        if not isinstance(v, ToolCallStartedEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolCallStartedEvent`")
        else:
            match += 1
        # validate data type: ToolCallCompletedEvent
        if not isinstance(v, ToolCallCompletedEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ToolCallCompletedEvent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SseEndpointMcpSseGet200ResponseData with oneOf schemas: RunCompletedEvent, RunResponseEvent, RunStartedEvent, ToolCallCompletedEvent, ToolCallStartedEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SseEndpointMcpSseGet200ResponseData with oneOf schemas: RunCompletedEvent, RunResponseEvent, RunStartedEvent, ToolCallCompletedEvent, ToolCallStartedEvent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into RunResponseEvent
        try:
            instance.actual_instance = RunResponseEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RunStartedEvent
        try:
            instance.actual_instance = RunStartedEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RunCompletedEvent
        try:
            instance.actual_instance = RunCompletedEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ToolCallStartedEvent
        try:
            instance.actual_instance = ToolCallStartedEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ToolCallCompletedEvent
        try:
            instance.actual_instance = ToolCallCompletedEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SseEndpointMcpSseGet200ResponseData with oneOf schemas: RunCompletedEvent, RunResponseEvent, RunStartedEvent, ToolCallCompletedEvent, ToolCallStartedEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SseEndpointMcpSseGet200ResponseData with oneOf schemas: RunCompletedEvent, RunResponseEvent, RunStartedEvent, ToolCallCompletedEvent, ToolCallStartedEvent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], RunCompletedEvent, RunResponseEvent, RunStartedEvent, ToolCallCompletedEvent, ToolCallStartedEvent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


